#property copyright "Copyright  2004, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Blue
#property indicator_color2 Red

extern double Step = 0.002;
extern double Maximum = 0.2;

double UpBuffer[];
double DownBuffer[];
double SarBuffer[];

int    save_lastreverse;
bool   save_dirlong;
double save_start;
double save_last_high;
double save_last_low;
double save_ep;
double save_sar;
int    bartime;

int init(){
   IndicatorBuffers(3);
   
   SetIndexStyle(0, DRAW_LINE);
   //SetIndexArrow(0, 159);
   SetIndexBuffer(0, UpBuffer);
   
   SetIndexStyle(1, DRAW_LINE);
   //SetIndexArrow(1, 159);
   SetIndexBuffer(1, DownBuffer);
   
   SetIndexBuffer(2, SarBuffer);
}

void SaveLastReverse(int last, int dir, double start, double low, double high, double ep, double sar) {
   save_lastreverse = last;
   save_dirlong     = dir;
   save_start       = start;
   save_last_low    = low;
   save_last_high   = high;
   save_ep          = ep;
   save_sar         = sar;
}

int start() {
   static bool first = true;
   bool dirlong;
   double start; 
   double last_high; 
   double last_low;
   
   double ep; 
   double sar; 
   double price;
   int    i;
   int counted_bars = IndicatorCounted();
   if(Bars < 3) {
       return(0);
   }    
   
   i = Bars - 2;
   
   if(counted_bars == 0 || first) {
       first = false;
       dirlong = true;
       start = Step;
       last_high = -10000000.0;
       last_low = 10000000.0;
       while(i > 0) {
           save_lastreverse = i;

           if(last_low > Low[i]) {
               last_low = Low[i];
           }

           if(last_high < High[i]) {
               last_high = High[i];
           }

           if(High[i] > High[i+1] && Low[i] > Low[i+1]) {
               break;
           }   
    
           if(High[i] < High[i+1] && Low[i] < Low[i+1]){ 
               dirlong = false; 
               break; 
           }
           i--;
       }


       if(dirlong){ 
           SarBuffer[i] = Low[i+1];
           ep = High[i];
       } else { 
           SarBuffer[i] = High[i+1]; 
           ep = Low[i]; 
       }
       i--;
    } else {
       i         = save_lastreverse;
       start     = save_start;
       dirlong   = save_dirlong;
       last_high = save_last_high;
       last_low  = save_last_low;
       ep        = save_ep;
       sar       = save_sar;

       if(Time[0] != bartime) {
           bartime = Time[0];
           i++;
       }       
   }
   
   while(i >= 0){
      if(dirlong && Low[i] < SarBuffer[i+1]){
         SaveLastReverse(i, true, start, Low[i], last_high, ep, sar);
         start        = Step; 
         dirlong      = false;
         ep           = Low[i];  
         last_low     = Low[i];
         SarBuffer[i] = last_high;
         i--;
      } else if(!dirlong && High[i] > SarBuffer[i+1]) {
         SaveLastReverse(i, false, start, last_low, High[i], ep, sar);
         start        = Step; 
         dirlong      = true;
         ep           = High[i]; 
         last_high    = High[i];
         SarBuffer[i] = last_low;
         i--;
      } else {

        price = SarBuffer[i+1];
 
        sar = SarBuffer[i+1] + start * (ep - SarBuffer[i+1]);
        if(dirlong) {
        //*
             if(ep < High[i] && (start + Step) <= Maximum) {
                 start += Step;
             }
             if(High[i] < High[i+1] && i == Bars - 2) {
                 sar = SarBuffer[i+1];
             }
    
             if(sar > Low[i+1]) {
                 sar = Low[i+1];
             }
           
             if(sar > Low[i+2]) {
                 sar = Low[i+2];
             }   //*/     
               
             if(sar > Low[i]) {
                 SaveLastReverse(i, true, start, Low[i], last_high, ep, sar);
                 start        = Step; 
                 dirlong      = false; 
                 ep           = Low[i];
                 last_low     = Low[i];
                 SarBuffer[i] = last_high;
                 i--;
                 continue;
             }
             
             if(ep < High[i]) {
                 last_high = High[i];
                 ep = High[i];
             }
        } else {
            
             if(ep > Low[i] && (start + Step) <= Maximum) {
                 start += Step;
             }
             if(Low[i] < Low[i+1] && i == Bars - 2) {
                 sar = SarBuffer[i+1];
             }

             if(sar < High[i+1]) {
                 sar = High[i+1];
             }
             
             if(sar < High[i+2]) {
                 sar = High[i+2];
             }
             //*/
             
             if(sar < High[i]){
                 SaveLastReverse(i, false, start, last_low, High[i], ep, sar);
                 start        = Step; 
                 dirlong      = true; 
                 ep           = High[i];
                 last_high    = High[i];
                 SarBuffer[i] = last_low;
                 i--;
                 continue;
             }
             if(ep > Low[i]){
                 last_low = Low[i]; 
                 ep       = Low[i]; 
             }
         }     
         SarBuffer[i] = sar;
         if(dirlong) {
            UpBuffer[i] = sar;
         } else {
            DownBuffer[i] = sar;
         }
         i--;
      }
   }      
}

